/*
 * RTSync: real-time compiler and runtime environment
 * Copyright (C) 2004  Stefan D. Bruda, Petter Haggholm, and Scott Stoddard
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program in a file named LICENSE; if not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef GRAPHMAKER_H
#define GRAPHMAKER_H

#include <iostream>


// Performs a static 'sanity check' on the generated code.  Checks to ensure
// that easily-visible, impossible constraints have not been entered.
// For example, a must-run-before (max constraint) that is sooner than a must-
// run-after (min).
//   Also, checks to ensure that no more than 1 max and 1 min constraint can
// be entered on any one relationship.
//   Returns true if the input is good, false if it is not, in  which case
// error messages are printed to stderr.
bool sanitycheck(std::istream& in);


#endif // #define GRAPHMAKER_H
