/*
 * RTSync: real-time compiler and runtime environment
 * Copyright (C) 2004  Stefan D. Bruda, Petter Haggholm, and Scott Stoddard
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program in a file named LICENSE; if not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef PARSE_UNION_H
#define PARSE_UNION_H


typedef union {
    int sym;
    char* txt;
    
    node* node_t;
    program_node* program_node_t;
    decl_list_node* decl_list_node_t;
    decl_node* decl_node_t;
    var_decl_node* var_decl_node_t;
    simple_var_decl_node* simple_var_decl_node_t;
    arr_var_decl_node* arr_var_decl_node_t;
    type_spec_node* type_spec_node_t;
    fun_decl_node* fun_decl_node_t;
    params_node* params_node_t;
    param_list_node* param_list_node_t;
    param_node* param_node_t;
    simple_param_node* simple_param_node_t;
    arr_param_node* arr_param_node_t;
    compound_stmt_node* compound_stmt_node_t;
    loc_decl_node* loc_decl_node_t;
    stmt_list_node* stmt_list_node_t;
    stmt_node* stmt_node_t;
    expr_stmt_node* expr_stmt_node_t;
    select_stmt_node* select_stmt_node_t;
    iter_stmt_node* iter_stmt_node_t;
    return_stmt_node* return_stmt_node_t;
    expr_node* expr_node_t;
    assign_expr_node* assign_expr_node_t;
    var_node* var_node_t;
    simple_var_node* simple_var_node_t;
    arr_var_node* arr_var_node_t;
    simple_expr_node* simple_expr_node_t;
    compound_simple_expr_node* compound_simple_expr_node_t;
    relop_node* relop_node_t;
    add_expr_node* add_expr_node_t;
    compound_add_expr_node* compound_add_expr_node_t;
    addop_node* addop_node_t;
    term_node* term_node_t;
    compound_term_node* compound_term_node_t;
    mulop_node* mulop_node_t;
    factor_node* factor_node_t;
    paren_factor_node* paren_factor_node_t;
    var_factor_node* var_factor_node_t;
    num_factor_node* num_factor_node_t;
    call_node* call_node_t;
    args_node* args_node_t;
    arg_list_node* arg_list_node_t;
    
    actor_node* actor_node_t;
    sync_node* sync_node_t;
    init_node* init_node_t;
    sync_init_node* sync_init_node_t;
    sync_decl_list_node* sync_decl_list_node_t;
    constraint_block_node* constraint_block_node_t;
    constraint_list_node* constraint_list_node_t;
    constraint_node* constraint_node_t;
    trigger_block_node* trigger_block_node_t;
    trigger_list_node* trigger_list_node_t;
    trigger_node* trigger_node_t;
    ed_trigger_node* ed_trigger_node_t;
    action_trigger_node* action_trigger_node_t;
    actor_params_node* actor_params_node_t;
    actor_param_node* actor_param_node_t;
    var_decls_node* var_decls_node_t;
    func_decls_node* func_decls_node_t;
    module_list_node* module_list_node_t;
    module_node* module_node_t;
    pass_node* pass_node_t;
    global_sync_node* global_sync_t;
    
    call_stmt_node* call_stmt_node_t;
    sync_call_stmt_node* sync_call_stmt_node_t;
    exception_block_node* exception_block_node_t;
} YYSTYPE;

#define YYSTYPE_IS_DECLARED

#ifndef YYMALLOC
#define YYMALLOC malloc
#endif
#ifndef YYFREE
#define YYFREE free
#endif

#endif // #define PARSE_UNION_H
