/*
 * RTSync: real-time compiler and runtime environment
 * Copyright (C) 2004  Stefan D. Bruda, Petter Haggholm, and Scott Stoddard
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program in a file named LICENSE; if not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef AST_DECLS_H
#define AST_DECLS_H

// Forward declaration of node types; see ast.h

struct node;
struct program_node;
struct module_node;
struct decl_list_node;
struct decl_node;
struct var_decl_node;
struct simple_var_decl_node;
struct arr_var_decl_node;
struct type_spec_node;
struct fun_decl_node;
struct exception_block_node;
struct params_node;
struct param_list_node;
struct param_node;
struct simple_param_node;
struct arr_param_node;
struct compound_stmt_node;
struct loc_decl_node;
struct stmt_list_node;
struct stmt_node;
struct expr_stmt_node;
struct select_stmt_node;
struct iter_stmt_node;
struct return_stmt_node;
struct expr_node;
struct assign_expr_node;
struct var_node;
struct simple_var_node;
struct arr_var_node;
struct simple_expr_node;
struct compound_simple_expr_node;
struct relop_node;
struct add_expr_node;
struct compound_add_expr_node;
struct addop_node;
struct term_node;
struct compound_term_node;
struct mulop_node;
struct factor_node;
struct paren_factor_node;
struct var_factor_node;
struct num_factor_node;
struct call_node;
struct args_node;
struct arg_list_node;
struct actor_node;
struct sync_node;
struct init_node;
struct sync_init_node;
struct sync_decl_list_node;
struct constraint_block_node;
struct constraint_list_node;
struct constraint_node;
struct trigger_block_node;
struct trigger_list_node;
struct trigger_node;
struct ed_trigger_node;
struct action_trigger_node;
struct actor_params_node;
struct actor_param_node;
struct var_decls_node;
struct func_decls_node;
struct module_list_node;
struct pass_node;
struct global_sync_node;

struct call_stmt_node;
struct sync_call_stmt_node;

#endif // #define AST_DECLS_H
