/*
 * RTSync: real-time compiler and runtime environment
 * Copyright (C) 2004  Stefan D. Bruda, Petter Haggholm, and Scott Stoddard
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program in a file named LICENSE; if not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "code_param_visitor.h"
#include "codevisitor.h"


void code_param_visitor::visit(int d, args_node* n) {
    n->args->accept(d+1, *this);
}

void code_param_visitor::visit(int d, arg_list_node* n) {
    if(n->head)
        n->head->accept(d, *this);
    
    out << indent(d) << "p << ";
    codevisitor v(out, graphout);
    n->tail->accept(d, v);
    out << ";\n";
}


