/*
 * RTSync: real-time compiler and runtime environment
 * Copyright (C) 2004  Stefan D. Bruda, Petter Haggholm, and Scott Stoddard
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program in a file named LICENSE; if not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef ACTIONLISTENER_H
#define ACTIONLISTENER_H

#include "reftypes.h"

class rttime_t;


// Symbolic interface to denote that the entity can receive event
// notifications
struct actionlistener
{
    // For actors to notify of events for action triggers
    virtual void notify_action(const actorref& a, const method& m,
                               const rttime_t& t) = 0;
};


#endif // #define ACTIONLISTENER_H
