/*
 * RTSync: real-time compiler and runtime environment
 * Copyright (C) 2004  Stefan D. Bruda, Petter Haggholm, and Scott Stoddard
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program in a file named LICENSE; if not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "net_id.h"

// To output net_ids.  Outputs the ip address as 4 characters representing
// the binary values of the 4 octets for ipv4.
std::ostream& operator<<(std::ostream& os, const net_id& id)
{
    using namespace std;
    const char* c = reinterpret_cast<const char*>(&id.ip_addr);
    os.write(c, 4);
    os << id.dest_port;
    return os;
}

// ip address must be in the form produced by the << operator
std::istream& operator>>(std::istream& is, net_id& id)
{
    while(is.peek() == ' ')
        is.ignore();

    char* cp = reinterpret_cast<char*>(&id.ip_addr);
    is.read(cp, 4);
    is >> id.dest_port;
    return is;
}
