#!/usr/bin/python

# RTSync: real-time compiler and runtime environment
# Copyright (C) 2004  Stefan D. Bruda, Petter Haggholm, and Scott Stoddard
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or (at
# your option) any later version.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program in a file named LICENSE; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
# MA 02111-1307, USA.

__module_name__="Message log parser"
__module_version__="0.1"
__module_description__="RTSync message log parser from Postgres"


# System services, like exit()
import sys
# Database services
from pg import DB

def format(num):
    x, trash = num.split(':')
    try:
        n = int(x)
        if n > 1000000:
            return 'infinity'
        else:
            return num
    except AttributeError:
        return num

uid, db, password, server = 'mickey', 'scott', 'mouse', 'delta'

try:
    con = DB(dbname=db, user=uid, passwd=password)
except:
    print 'Error connecting to server:',
    print server
    sys.exit(1)


# Keep doing queries while the user so desires
while True:
    print ''
    no = raw_input('Fetch which message? ')
    print ''
    
    query = 'SELECT * FROM messages WHERE serial=%s' % no
    qres = con.query(query)
    if qres == None or len(qres.dictresult()) == 0:
        print 'No such message exists!'
        continue
    
    results = qres.dictresult()
    final = results[len(results)-1]
    
    print 'Message #%i:' % final['serial']
    print '  From %s to %s' % (final['source'], final['destination'])
    print '  Synchronized by %s' % final['sync']
    print '  Parameters: %s' % final['params']
    
    print '  %13s   %13s   %13s   %13s   %13s   %13s' \
    % ('CREATION TIME', 'DISPATCH TIME', 'RECEIVED TIME', 'EXECUTED TIME', 'RUN BY', 'RUN AFTER')
    for i in results:
        print '  %13s   %13s   %13s   %13s   %13s   %13s' \
        % (i['creation'], i['dispatch'], i['received'], i['executed'], format(i['before']), format(i['after']))
    print
        
    # serial, sender, receiver, sync, create, dispatch, received, executed, before, after
